#include "main.h"
#include "usart.h"

//extern volatile unsigned int rc5_data;	//Globale Variable zum speichern des RC5 ergebnises
extern volatile unsigned char command[CMD_LENGTH]; // Puffer fr Kommando vom PC
extern volatile unsigned char command_count; //Variable zum zhlen der empfangenen Zeichen
extern volatile unsigned char command_ctrl; //Variable zum steuern des Empfangs

//SIGNAL(SIG_USART0_RECV) befindet sich in usart.c

//Hauptfunktion
int main (void){

	USART_init(); //USART initialisieren

	sei(); // Interrupts einschalten
	
	for(;;){ //Hauptschleife
		if (command_ctrl == STOPCODE_EMPF){ //Testen ob Befehl vollstndig
			switch (command[0]){
				case DISPLAY_CLEAR:{
					lcd_clear();
					break;
				}
				case DISPLAY_GOTO:{
					lcd_goto(command[1],command[2]);
					break;
				}	
				case DISPLAY_LINE:{
					for (int i=1;i<(command_count);i++){
						lcd_chr(command[i]);
					}
					break;
				}
				case EEPROM_READ:{
				USART_chr (eeprom_read_byte(command[1]));
				break;
				}
				case EEPROM_WRITE:{
				eeprom_write_byte (command[1],command[2]);
				break;
				}
			}
			command_ctrl = 0;	//Wenn kommando verarbeitet wieder auf null setzen
			command_count = 0;	//Zhler auf null zurckstellen
		}
	}
}