#include "main.h"
#include "usart.h"

volatile unsigned char command[CMD_LENGTH];		// Puffer fr Kommando vom PC
volatile unsigned char command_count = 0;		//Variable zum zhlen der empfangenen Zeichen
volatile unsigned char command_ctrl = 0;			//Variable zum steuern des Empfangs

//Interuptfunktion fr UART0
SIGNAL(SIG_USART0_RECV){
	unsigned char data = UDR0; //Puffer fr den empfang aus dem USART	
	switch (data){
		case CMD_STARTCODE:{	//Wenn das Startzeichen empfangen wurde
			command_ctrl = STARTCODE_EMPF;
			command_count = 0;
			break;
		}
		case CMD_STOPCODE:{	//Wenn stopcode empfangen wurde
			command_ctrl = STOPCODE_EMPF;
			break;
		}
		default:{	//Wenn beliebiges zeichen empfangen wurde
			command[command_count] = data;
			command_count++;
		}
	}
} 

//Funktion zum initialisieren des USART
void USART_init(void){
	UCSR0B =  _BV(RXCIE0) | _BV(RXEN0) | _BV(TXEN0); //Interupt bei Empfang(RXCIE0),Empfang(RXEN0) und Senden(TXEN0) aktivieren
	UCSR0C = (3<<UCSZ00); //Frame Format: 8data, 1stop bit
	//Einstellen des USART geschwindigkeit
	UBRR0L = USART_BAUD_SELECT;
	UBRR0H = USART_BAUD_SELECT >> 8;
}

//Funktion zum senden vom einzelnen Zeichen ber das USART
void USART_chr (unsigned char data) {	
	while (!(UCSR0A & (1<<UDRE0))) {} //Warten bis letztes zeichen gesendet wurde
	UDR0 = data; //Zeichen senden
}

//Funktion zum senden vom Strings ber das USART
void USART_str (unsigned char *string) {
    while (!(UCSR0A & (1<<UDRE0))) {} //Warten bis letztes zeichen gesendet wurde
	while ( *string) USART_chr (*string++); //Aufrufen von USART_send fr jedes Zeichen des Strings
}
